Index: res/res_musiconhold.c
===================================================================
RCS file: /usr/cvsroot/asterisk/res/res_musiconhold.c,v
retrieving revision 1.10
diff -u -r1.10 res_musiconhold.c
--- res/res_musiconhold.c	27 Sep 2003 02:45:37 -0000	1.10
+++ res/res_musiconhold.c	28 Oct 2003 17:57:28 -0000
@@ -33,6 +33,7 @@
 #include <sys/time.h>
 #include <sys/signal.h>
 #include <netinet/in.h>
+#include <sys/types.h>
 #include <sys/stat.h>
 #include <dirent.h>
 #ifdef ZAPATA_MOH
@@ -596,16 +597,65 @@
 	ast_mutex_unlock(&moh_lock);
 }
 
+static int has_correct_mpg123(void)
+{
+	int count = 0, res = 0;
+	FILE *CHECK;
+	char *home, *path, *newpath;
+	char checkfile[256];
+	char command[384];
+	struct stat statbuf;
+
+	home = getenv("HOME");
+	if (home) {
+		snprintf(checkfile,255,"%s/.mpg123_check_XXXXXX", home);
+	} else {
+		strncpy(checkfile,"/tmp/.mpg123_check_XXXXXX",255);
+	}
+	mkstemp(checkfile);
+	snprintf(command,383,"echo | strings `which mpg123 2>/dev/null` | grep -c mpg123 >%s",checkfile);
+	/* Ensure PATH contains both /usr/bin and /usr/local/bin */
+	path = getenv("PATH");
+	if (path) {
+		newpath = alloca(strlen(path) + strlen(":/bin:/usr/bin:/usr/local/bin") + 1);
+		sprintf(newpath, "%s:/bin:/usr/bin:/usr/local/bin", path);
+	} else {
+		newpath = "/bin:/usr/bin:/usr/local/bin";
+	}
+	setenv("PATH",newpath,1);
+	system(command);
+	/* Restore PATH */
+	if (path)
+		setenv("PATH",path,1);
+	else
+		unsetenv("PATH");
+
+	if ((CHECK = fopen(checkfile, "r"))) {
+		fscanf(CHECK,"%d",&count);
+
+		if (count > 0) {
+			res = 1;
+		}
+		fclose(CHECK);
+	}
+	unlink(checkfile);
+	return res;
+}
+
 int load_module(void)
 {
-	int res;
-	load_moh_classes();
-	res = ast_register_application(app0, moh0_exec, synopsis0, descrip0);
-	ast_register_atexit(ast_moh_destroy);
-	if (!res)
-		res = ast_register_application(app1, moh1_exec, synopsis1, descrip1);
-	if (!res)
-		res = ast_register_application(app2, moh2_exec, synopsis2, descrip2);
+	int res = 0;
+	if (has_correct_mpg123()) {
+		load_moh_classes();
+		res = ast_register_application(app0, moh0_exec, synopsis0, descrip0);
+		ast_register_atexit(ast_moh_destroy);
+		if (!res)
+			res = ast_register_application(app1, moh1_exec, synopsis1, descrip1);
+		if (!res)
+			res = ast_register_application(app2, moh2_exec, synopsis2, descrip2);
+	} else {
+		ast_log(LOG_ERROR, "Correct version of mpg123 not detected (perhaps you have mpg321?)  Disabling MusicOnHold\n");
+	}
 	return res;
 }
 
